net.sf.cpsolver.coursett.criteria.additional

## Class QuadraticStudentConflict

- java.lang.Object
- - net.sf.cpsolver.ifs.criteria.AbstractCriterion<Lecture,Placement>
  - - net.sf.cpsolver.coursett.criteria.TimetablingCriterion
    - - net.sf.cpsolver.coursett.criteria.StudentConflict
      - - net.sf.cpsolver.coursett.criteria.additional.QuadraticStudentConflict

- All Implemented Interfaces:
    Criterion<Lecture,Placement>, InfoProvider<Lecture>, ModelListener<Lecture,Placement>
  Direct Known Subclasses:
    QuadraticStudentHardConflict

      public class QuadraticStudentConflict
      extends StudentConflict

  Quadratic student conflicts. Same as `StudentConflict`, however, student joint enrollments are squared (1 conflict counts as 1, 2 as 4, 3 as 9, etc.).
  Version:
    CourseTT 1.2 (University Course Timetabling)
    Copyright (C) 2006 - 2011 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class net.sf.cpsolver.ifs.criteria.AbstractCriterion

      `AbstractCriterion.ValueUpdateType`

  - ### Field Summary

    - ### Fields inherited from class net.sf.cpsolver.coursett.criteria.StudentConflict

      `iIncludeConflicts`

    - ### Fields inherited from class net.sf.cpsolver.ifs.criteria.AbstractCriterion

      `iBest, iDebug, iValue, iValueUpdateType, iWeight, sDoubleFormat, sPercentFormat`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `QuadraticStudentConflict()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `getPlacementSelectionWeightName()`
    `double` | `getWeightDefault(DataProperties config)` Defines default weight (when `AbstractCriterion.getWeightName()` parameter is not present in the criterion).
    `void` | `incJenrl(JenrlConstraint jenrl, double studentWeight, Double conflictPriority, Student student)`
    `boolean` | `isApplicable(Lecture l1, Lecture l2)`
    `protected double` | `jointEnrollment(JenrlConstraint jenrl)`

    - ### Methods inherited from class net.sf.cpsolver.coursett.criteria.StudentConflict

      `applicable, applicable, bestRestored, committed, committed, distance, getBounds, getBounds, getMetrics, getValue, getValue, getValue, hard, hard, ignore, ignore, inConflict, init, overlaps`

    - ### Methods inherited from class net.sf.cpsolver.coursett.criteria.TimetablingCriterion

      `getAbbreviation, getPlacementSelectionWeight, getPlacementSelectionWeightDefault, toString`

    - ### Methods inherited from class net.sf.cpsolver.ifs.criteria.AbstractCriterion

      `afterAssigned, afterUnassigned, beforeAssigned, beforeUnassigned, bestSaved, clearCache, computeBounds, constraintAdded, constraintRemoved, getBest, getInfo, getInfo, getModel, getName, getPerc, getPercRev, getWeight, getWeightedBest, getWeightedValue, getWeightedValue, getWeightedValue, getWeightName, inc, variableAdded, variableRemoved`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### QuadraticStudentConflict

          public QuadraticStudentConflict()

  - ### Method Detail

    - #### isApplicable

          public boolean isApplicable(Lecture l1,
                                      Lecture l2)

      Overrides:
        `isApplicable` in class `StudentConflict`

    - #### getWeightDefault

          public double getWeightDefault(DataProperties config)

      Description copied from class: `AbstractCriterion`
      Defines default weight (when `AbstractCriterion.getWeightName()` parameter is not present in the criterion).
      Overrides:
        `getWeightDefault` in class `AbstractCriterion<Lecture,Placement>`

    - #### getPlacementSelectionWeightName

          public String getPlacementSelectionWeightName()

      Overrides:
        `getPlacementSelectionWeightName` in class `StudentConflict`

    - #### jointEnrollment

          protected double jointEnrollment(JenrlConstraint jenrl)

      Overrides:
        `jointEnrollment` in class `StudentConflict`

    - #### incJenrl

          public void incJenrl(JenrlConstraint jenrl,
                               double studentWeight,
                               Double conflictPriority,
                               Student student)

      Overrides:
        `incJenrl` in class `StudentConflict`